/******************************************/
/* timer_expire.h 0.1.0 (1999-Dec-16-Thu) */
/* Adam M. Costello <amc@cs.berkeley.edu> */
/******************************************/

/* Cause the next scheduled timer to */
/* expire, or find out when it will. */

/* This is ANSI C code. */


#ifndef TIMER_EXPIRE_H
#define TIMER_EXPIRE_H


int timer_expire(void);

    /* If there are no timers currently set, does */
    /* nothing and returns 0.  Otherwise advances */
    /* the current time to the expiration time of */
    /* the next timer due to expire, causes it to */
    /* expire, and returns 1.                     */


double timer_next(void);

    /* Returns what the current time will become */
    /* after the next call to timer_expire().    */


#endif /* TIMER_EXPIRE_H */
